// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dataspeed_ulc_msgs:msg/UlcReport.idl
// generated code does not contain a copyright notice
#include "dataspeed_ulc_msgs/msg/detail/ulc_report__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
dataspeed_ulc_msgs__msg__UlcReport__init(dataspeed_ulc_msgs__msg__UlcReport * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    dataspeed_ulc_msgs__msg__UlcReport__fini(msg);
    return false;
  }
  // pedals_enabled
  // steering_enabled
  // speed_preempted
  // steering_preempted
  // override_latched
  // timeout
  // steering_mode
  // tracking_mode
  // speed_ref
  // speed_meas
  // accel_ref
  // accel_meas
  // max_steering_angle
  // max_steering_vel
  return true;
}

void
dataspeed_ulc_msgs__msg__UlcReport__fini(dataspeed_ulc_msgs__msg__UlcReport * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // pedals_enabled
  // steering_enabled
  // speed_preempted
  // steering_preempted
  // override_latched
  // timeout
  // steering_mode
  // tracking_mode
  // speed_ref
  // speed_meas
  // accel_ref
  // accel_meas
  // max_steering_angle
  // max_steering_vel
}

dataspeed_ulc_msgs__msg__UlcReport *
dataspeed_ulc_msgs__msg__UlcReport__create()
{
  dataspeed_ulc_msgs__msg__UlcReport * msg = (dataspeed_ulc_msgs__msg__UlcReport *)malloc(sizeof(dataspeed_ulc_msgs__msg__UlcReport));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dataspeed_ulc_msgs__msg__UlcReport));
  bool success = dataspeed_ulc_msgs__msg__UlcReport__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
dataspeed_ulc_msgs__msg__UlcReport__destroy(dataspeed_ulc_msgs__msg__UlcReport * msg)
{
  if (msg) {
    dataspeed_ulc_msgs__msg__UlcReport__fini(msg);
  }
  free(msg);
}


bool
dataspeed_ulc_msgs__msg__UlcReport__Sequence__init(dataspeed_ulc_msgs__msg__UlcReport__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  dataspeed_ulc_msgs__msg__UlcReport * data = NULL;
  if (size) {
    data = (dataspeed_ulc_msgs__msg__UlcReport *)calloc(size, sizeof(dataspeed_ulc_msgs__msg__UlcReport));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dataspeed_ulc_msgs__msg__UlcReport__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dataspeed_ulc_msgs__msg__UlcReport__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dataspeed_ulc_msgs__msg__UlcReport__Sequence__fini(dataspeed_ulc_msgs__msg__UlcReport__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dataspeed_ulc_msgs__msg__UlcReport__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dataspeed_ulc_msgs__msg__UlcReport__Sequence *
dataspeed_ulc_msgs__msg__UlcReport__Sequence__create(size_t size)
{
  dataspeed_ulc_msgs__msg__UlcReport__Sequence * array = (dataspeed_ulc_msgs__msg__UlcReport__Sequence *)malloc(sizeof(dataspeed_ulc_msgs__msg__UlcReport__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = dataspeed_ulc_msgs__msg__UlcReport__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
dataspeed_ulc_msgs__msg__UlcReport__Sequence__destroy(dataspeed_ulc_msgs__msg__UlcReport__Sequence * array)
{
  if (array) {
    dataspeed_ulc_msgs__msg__UlcReport__Sequence__fini(array);
  }
  free(array);
}
